%define major 6
%define lib_name_orig lib%{name}
%define libname %mklibname %{name} %{major}
%define develname %mklibname %{name} -d

Summary:	Library for reading lines from a terminal
Name:		readline
Version:	6.2
Release:	%mkrel 1
License:	GPLv2+
Group:		System/Libraries
Url:		http://tiswww.case.edu/php/chet/readline/rltop.html
Source0:	ftp://ftp.gnu.org/gnu/readline/%{name}-%{version}.tar.gz
Source1:	ftp://ftp.gnu.org/gnu/readline/%{name}-%{version}.tar.gz.sig
Patch0:		readline-4.3-no_rpath.patch
Patch1:		readline-4.1-outdated.patch
Patch2:		rl-header.patch
Patch3:		rl-attribute.patch
Patch4:		readline-6.0-fix-shared-libs-perms.patch
# upstream patches:
Patch101:	ftp://ftp.gnu.org/gnu/readline/readline-6.2-patches/readline62-001
BuildRequires:	libncurses-devel

%description
The "readline" library will read a line from the terminal and return it,
allowing the user to edit the line with the standard emacs editing keys.
It allows the programmer to give the user an easier-to-use and more
intuitive interface.

%package -n %{libname}
Summary:	Shared libraries for readline
Group:		System/Libraries
Obsoletes:	%{name}
Provides:	%{name} = %{version}-%{release}

%description -n	%{libname}
This package contains the library needed to run programs dynamically
linked to readline.

%package doc
Summary:	Readline documentation in GNU info format
Group:		Books/Computer books
Provides:	%{name}-doc = %{version}-%{release}
Requires:	%{libname} = %{version}-%{release}
Obsoletes:	%{libname}-doc

%description doc
This package contains readline documentation in the GNU info format.

%package -n %{develname}
Summary:	Files for developing programs that use the readline library
Group:		Development/C
Requires:	%{libname} = %{version}-%{release}
Obsoletes:	%{name}-devel < 6.0-2
Provides:	%{lib_name_orig}-devel = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Requires:	libncurses-devel 
Obsoletes:	%{mklibname readline 5 -d}

%description -n	%{develname}
The "readline" library will read a line from the terminal and return it,
using prompt as a prompt.  If prompt is null, no prompt is issued.  The
line returned is allocated with malloc(3), so the caller must free it when
finished.  The line returned has the final newline removed, so only the
text of the line remains.

%prep
%setup -q
%patch0 -p1 -b .no_rpath
%patch1 -p1 -b .outdated
%patch2 -p1 -b .header
%patch3 -p1 -b .attribute
%patch4 -p1 -b .fix-perms
%patch101 -p0 -b .001

libtoolize --copy --force

%build
export LDFLAGS="-I%{_includedir}/ncurses -lncurses"
export CFLAGS="%{optflags} -I%{_includedir}/ncurses -lncurses"
export CXXFLAGS="%{optflags} -I%{_includedir}/ncurses -lncurses"

%configure2_5x \
	 --with-curses \
	 --enable-multibyte

perl -p -i -e 's|-Wl,-rpath.*||' shlib/Makefile

%make

%install
rm -rf %{buildroot}
%makeinstall_std

# put all libs in /lib because some package needs it
# before /usr is mounted
install -d %{buildroot}/%{_lib}
mv %{buildroot}%{_libdir}/*.so* %{buildroot}/%{_lib}
ln -s ../../%{_lib}/lib{history,readline}.so %{buildroot}%{_libdir}

# The make install moves the existing libs with a suffix of old. Urgh.
rm -f %{buildroot}/%{_lib}/*.old

perl -p -i -e 's|/usr/local/bin/perl|/usr/bin/perl|' doc/texi2html

%clean
rm -rf %{buildroot}

%post doc
%{_install_info history.info}
%{_install_info readline.info}

%preun doc
%{_remove_install_info history.info}
%{_remove_install_info readline.info}

%files -n %{libname}
%defattr(-,root,root)
/%{_lib}/lib*.so.%{major}*

%files doc
%{_infodir}/*info*

%files -n %{develname}
%defattr(-,root,root)
%doc CHANGELOG CHANGES MANIFEST README USAGE
%doc doc examples support
%{_mandir}/man3/*
%{_datadir}/readline
%{_includedir}/readline
%{_libdir}/lib*.a
%{_libdir}/lib*.so
/%{_lib}/*so


%changelog
* Fri Apr 15 2011 ahmad <ahmad> 6.2-1.mga1
+ Revision: 85627
- update to 6.2
- add upstream patch 001

* Sat Jan 08 2011 blino <blino> 6.1-4.mga1
+ Revision: 655
- remove old ldconfig calls
- imported package readline


* Fri Dec 03 2010 Oden Eriksson <oeriksson@mandriva.com> 6.1-3mdv2011.0
+ Revision: 607337
- rebuild

* Wed Mar 31 2010 Guillaume Rousse <guillomovitch@mandriva.org> 6.1-2mdv2010.1
+ Revision: 530534
- apply 2 official patches

* Sat Jan 02 2010 Frederik Himpe <fhimpe@mandriva.org> 6.1-1mdv2010.1
+ Revision: 484989
- Update to new version 6.1
- Remove patches integrated upstream

* Sun Jun 28 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 6.0-2mdv2010.0
+ Revision: 390322
- add three upstream patches
- spec file clean

* Tue Feb 24 2009 Guillaume Rousse <guillomovitch@mandriva.org> 6.0-1mdv2009.1
+ Revision: 344412
- new version
- drop merged patches
- drop undocumented readline-5.2-inv.patch
- new devel policy
- rename doc package to readline-doc

* Wed Jan 14 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 5.2-11mdv2009.1
+ Revision: 329253
- enable multibyte characters

* Mon Dec 22 2008 Oden Eriksson <oeriksson@mandriva.com> 5.2-10mdv2009.1
+ Revision: 317557
- rebuild

* Thu Aug 07 2008 Thierry Vignaud <tv@mandriva.org> 5.2-9mdv2009.0
+ Revision: 265632
- rebuild early 2009.0 package (before pixel changes)

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

* Wed May 28 2008 Funda Wang <fwang@mandriva.org> 5.2-8mdv2009.0
+ Revision: 212604
- add more ubuntu patches
- hardlink against ncurses

  + Tomasz Pawel Gajc <tpg@mandriva.org>
    - add requires on libncurses-devel for devel package

  + Thierry Vignaud <tv@mandriva.org>
    - fix no-buildroot-tag

* Mon Dec 31 2007 Tomasz Pawel Gajc <tpg@mandriva.org> 5.2-7mdv2008.1
+ Revision: 139706
- new license policy
- use upstream source file, add *.sig
- reorganize patches
- add ten upstream patches - mostly they fixes displaying characters under bash, more info can be found in each patch file
- compile against ncurses
- use macros
- make use of %%major in spec file
- spec file clean

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request

* Wed Sep 19 2007 Guillaume Rousse <guillomovitch@mandriva.org> 5.2-6mdv2008.0
+ Revision: 90249
- rebuild

* Tue Sep 18 2007 Anssi Hannula <anssi@mandriva.org> 5.2-5mdv2008.0
+ Revision: 89540
- rebuild due to package loss

* Thu Jun 07 2007 Anssi Hannula <anssi@mandriva.org> 5.2-4mdv2008.0
+ Revision: 36197
- rebuild with correct optflags

  + Thierry Vignaud <tv@mandriva.org>
    - kill bogus patch 5 (#28432), add by Geoffrey Lee in 4.1-15mdk on behalf of
      <mlord@pobox.com>, with no explanation

* Mon May 28 2007 Ademar de Souza Reis Jr <ademar@mandriva.com.br> 5.2-2mdv2008.0
+ Revision: 32180
+ rebuild (emptylog)

* Mon May 28 2007 Ademar de Souza Reis Jr <ademar@mandriva.com.br> 5.2-1mdv2008.0
+ Revision: 32035
- introduce readline-doc package, with info documentation. The
  manuals were on the -devel package, but they're of general use.


* Thu Feb 01 2007 Emmanuel Andry <eandry@mandriva.org> 5.2-1mdv2007.0
+ Revision: 115840
- New version 5.2
- drop patches 11 and 18
- add upstream patch (P12)

* Sun Oct 15 2006 Oden Eriksson <oeriksson@mandriva.com> 5.1-3mdv2007.0
+ Revision: 64867
- bzip2 cleanup
- rebuild

* Thu Oct 12 2006 Oden Eriksson <oeriksson@mandriva.com> 5.1-2mdv2007.1
+ Revision: 63476
- bunzip patches
- Import readline

* Wed Jan 04 2006 Thierry Vignaud <tvignaud@mandriva.com> 5.1-1mdk
- new release
- drop patch 2 (was merged long ago but was still wrongly aplied because patch
  defaults to -F 2 :-( )
- drop patch 4 (rh patch dropped in fedora)
- drop patch 17 (merged upstream)
- drop patches 11 to 15 (upstream patches)
- patch 11: add official patch

* Sun Jan 01 2006 Mandriva Linux Team <http://www.mandrivaexpert.com/> 5.0-3mdk
- Rebuild

* Sun Jan 23 2005 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 5.0-2mdk
- from fedora:
	o Fix line-wrapping (bug #145329).
	o Apply "read -e" patch from bash package.

* Thu Jan 20 2005 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 5.0-1mdk
- 5.0
- bump major
- sync with fedora patches
- drop P1 (weren't applied), P100 & P101 (merged upstream)
- add url
- cosmetics

* Wed Dec 29 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 4.3-9mdk
- revert latest "lib64 fixes"

* Wed Dec 29 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 4.3-8mdk
- lib64 fixes

